unit Unit5;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, ComCtrls, ExtCtrls, StdCtrls,
  UnitV ;

type
  TForm5 = class(TForm)
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    StringGrid1: TStringGrid;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Label1: TLabel;
    ComboBox1: TComboBox;
    Label2: TLabel;
    ComboBox2: TComboBox;
    Edit1: TEdit;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ComboBox1Select(Sender: TObject);
    procedure ComboBox2Select(Sender: TObject);
  private
    { Private 錾 }
    n,n1,n2 : integer ;
    wh1,od1 : string ;
    procedure SCellClear ;
    procedure SCellDisplay ;
  public
    { Public 錾 }
  end;

var
  Form5: TForm5;

implementation

uses
   Unit1 ;

{$R *.dfm}

// N
procedure TForm5.FormShow(Sender: TObject);
begin
   n  := 100 ;    // 1y[W̃f[^
   n1 := 1 ;      // 擪R[hԍ
   n2 := 0 ;      // ł̃R[hԍ
   wh1:= '';      // WHERE߁ii荞ݗpj
   od1:= 'N';     // ORDER BYiяpj
   ComboBox1.ItemIndex := 0 ;
   ComboBox1Select(Sender);
   ComboBox2.ItemIndex := 0 ;
   with StringGrid1 do begin
      Cells[ 0,0] := 'o^ԍ';
      Cells[ 1,0] := 'PCpҖ';
      Cells[ 2,0] := 'tH_';
      Cells[ 3,0] := 'WJtH_';
      Cells[ 4,0] := 't@C';
      Cells[ 5,0] := 'Nt';
      Cells[ 6,0] := 'N';
      Cells[ 7,0] := 't@Ct';
      Cells[ 8,0] := 't@C';
      Cells[ 9,0] := 't@CTCY';
      RowCount := n + 1;
   end;
   SCellClear ;
   Button1.Enabled := True ;
   Button2.Enabled := True ;
   Button3.Enabled := True ;
   Button4.Enabled := True ;
   if not(Form1.IBDatabase1.Connected) then begin
      Button1.Enabled := False ;
      Button2.Enabled := False ;
      Button3.Enabled := False ;
      Button4.Enabled := False ;
      exit ;
   end;
   // e[umF
   if not(Form1.DataTableCheck(TABLE1)) then begin
      // e[u݂Ȃ̂Ńe[u쐬
      if not(Form1.DataTableMaking1) then begin
         Button1.Enabled := False ;
         Button2.Enabled := False ;
         Button3.Enabled := False ;
         Button4.Enabled := False ;
      end;
   end
   else begin
      Button1Click(Sender);
   end;
   Button1.SetFocus ;
end;

// I
procedure TForm5.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   //
end;

// eNA
procedure TForm5.SCellClear ;
var
   i,j : integer ;
begin
   with StringGrid1 do begin
      for j:=1 to RowCount-1 do
         for i:=0 to ColCount-1 do
            Cells[i,j] := '';
   end;
end;

// f[^ǂݍ
procedure TForm5.SCellDisplay ;
var
   i,j : integer ;
begin
   with Form1 do begin
      IBQuery1.Active := False ;
      IBTransaction1.Active := False ;
      IBQuery1.ParamCheck := True ;
      with IBQuery1.SQL do begin
         Clear ;
         Add('SELECT * FROM '+TABLE1);
         if (wh1 <> '') then begin
            Add('  WHERE ' + wh1);
         end;
         Add('  ORDER BY ' + od1 + ';');
      end;
      j := 1 ;
      //
      try
         IBQuery1.Open ;
         IBQuery1.First ;
         if (n1 > 1) then IBQuery1.MoveBy(n1-1);
         while not(IBQuery1.Eof) do begin
            for i:=0 to 9 do begin
               Form5.StringGrid1.Cells[i,j] := IBQuery1.Fields[i].AsString ;
            end;
            Inc(j);
            if (j > n) then break ;
            IBQuery1.Next ;
         end;
      except
         ;
      end;
      IBQuery1.Active := False ;
      n2 := n1 + j - 1;
   end;
end;

// ŏ
procedure TForm5.Button1Click(Sender: TObject);
begin
   SCellClear ;
   n1 := 1 ;
   SCellDisplay ;
end;

// O
procedure TForm5.Button2Click(Sender: TObject);
begin
   SCellClear ;
   if (n1 > 1) then begin
      n1 := n1 - n ;
      if (n1 < 1) then n1 := 1 ;
   end;
   SCellDisplay ;
end;

// 
procedure TForm5.Button3Click(Sender: TObject);
begin
   SCellClear ;
   n1 := n2 ;
   SCellDisplay ;
end;

// XV
procedure TForm5.Button4Click(Sender: TObject);
begin
   SCellClear ;
   SCellDisplay ;
end;

// яύX
procedure TForm5.ComboBox1Select(Sender: TObject);
var
   i : integer ;
begin
   i := ComboBox1.ItemIndex ;
   if (i = -1) then exit ;
   Case(i)of
    0:begin // o^ԍ
         od1 := 'N' ;
      end;
    1:begin // o^ԍ
         od1 := 'N DESC' ;
      end;
    2:begin // PCpҖ
         od1 := 'PNAME' ;
      end;
    3:begin // PCpҖ
         od1 := 'PNAME DESC' ;
      end;
    4:begin // tH_
         od1 := 'L_FOLDER' ;
      end;
    5:begin // tH_
         od1 := 'L_FOLDER DESC' ;
      end;
    6:begin // WJtH_
         od1 := 'N_FOLDER' ;
      end;
    7:begin // WJtH_
         od1 := 'N_FOLDER DESC' ;
      end;
    8:begin // t@C
         od1 := 'FILE_NAME' ;
      end;
    9:begin // t@C
         od1 := 'FILE_NAME DESC' ;
      end;
   10:begin // N
         od1 := 'BOOT_DATE,BOOT_TIME' ;
      end;
   11:begin // N
         od1 := 'BOOT_DATE DESC,BOOT_TIME DESC' ;
      end;
   12:begin // t@C
         od1 := 'FILE_DATE,FILE_TIME' ;
      end;
   13:begin // t@C
         od1 := 'FILE_DATE DESC,FILE_TIME DESC' ;
      end;
   14:begin // t@CTCY
         od1 := 'FILE_SIZE' ;
      end;
   15:begin // t@CTCY
         od1 := 'FILE_SIZE DESC' ;
      end;
   end;

   Button1Click(Sender);   // ŏ
end;

// i荞
procedure TForm5.ComboBox2Select(Sender: TObject);
var
   i : integer ;
   s : string ;
begin
   i := ComboBox2.ItemIndex ;
   if (i = -1) then exit ;
   s := Edit1.Text ;
   if (s = '') then i := 0 ;
   Case(i)of
    0:begin // ij
         wh1 := '';
      end;
    1:begin // PCpҖ
         wh1 := 'PNAME' ;
      end;
    2:begin // tH_
         wh1 := 'L_FOLDER' ;
      end;
    3:begin // WJtH_
         wh1 := 'N_FOLDER' ;
      end;
    4:begin // t@C
         wh1 := 'FILE_NAME' ;
      end;
    5:begin // Nt
         wh1 := 'BOOT_DATE' ;
      end;
    6:begin // t@Ct
         wh1 := 'FILE_DATE' ;
      end;
   end;

   if (wh1 <> '') then begin
      wh1 := wh1 + ' LIKE ''%' + s + '%''' ;
   end;
   Button1Click(Sender);   // ŏ
end;

end.
