unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Registry,
  UnitV ;

type
  TForm3 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Panel1: TPanel;
    Label4: TLabel;
    Edit1: TEdit;
    Label5: TLabel;
    ListBox1: TListBox;
    LabelA: TLabel;
    Timer1: TTimer;
    LabelB: TLabel;
    LabelC: TLabel;
    ListBox2: TListBox;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private 錾 }
    function  GetJWWFilePath : string ;
    function  GetNetDrive(drv:string):string;
    procedure DBDataAdd(fn:string);
  public
    { Public 錾 }
  end;

var
  Form3: TForm3;
  FileSelect : Boolean ;

implementation

uses
   Unit1 ;

{$R *.dfm}

// NAv擾i`FbNpj
function EnumWndProcCheck(h:HWND; lParam:integer):Boolean; stdcall;
var
	ClassName,Caption: array [0..255] of Char;
   s : string ;
   i : integer ;
begin
	if IsWindowVisible(h) then begin
   	GetWindowText(h, Caption, 255);
      GetClassName(h, ClassName, 255);
     	s := string(Caption) ;
      i := AnsiPos('t@CI',s);
      if (i > 0) then
         FileSelect := True ;
   end;
   Result := True ;
end;

// NAv擾
function EnumWndProc(h:HWND; lParam:integer):Boolean; stdcall;
var
	ClassName,Caption: array [0..255] of Char;
   s : string ;
   i : integer ;
   f : Boolean ;
begin
	if (GetWindow(h, GW_OWNER) = 0)and IsWindowVisible(h) then begin
   	GetWindowText(h, Caption, 255);
      GetClassName(h, ClassName, 255);
     	s := string(Caption) ;
      i := AnsiPos(' - jw_win',s);
      if (i > 0) then begin
         s := Copy(s,1,i-1) ;
         if (s <> '') then begin
            s := s + ' :H'+IntToStr(h);
	   		f := False ;
		   	for i:=0 to Form3.ListBox2.Items.Count-1 do begin
			   	if (AnsiPos(s, Form3.ListBox2.Items[i]) > 0) then begin
               	f := True ;
                  break;
               end;
            end;
		   	if not(f) then
     		   	Form3.ListBox2.Items.Add(Form3.LabelA.Caption+s);
         end;
		end;
   end;
   Result := True ;
end;

// WXg񂩂JWWt@CJpX擾
// AA^C~OɂĂ͈قȂ\L蓾̂Œ
function TForm3.GetJWWFilePath : string ;
var
	reg : TRegIniFile;
   s : string ;
begin
	s := '';
   // WXgJWWtH_ݒ擾
	try
		reg := TRegIniFile.create('SOFTWARE\Jw_cad\jw_win\');
		s := reg.ReadString('Folder', 'File', '');
		reg.free;
		s := s + '\' ;
   except
		;
   end;
	Result := s ;
end;

// hCů蓖ĂĂ鋤LfBNg擾
//		drv : zhCuiD:AH:AEEEj
//		ret : LfBNg
//				Ⴄꍇ́AhCû܂ܕԂ
function TForm3.GetNetDrive(drv:string):string;
var
	ShareName: array[0..255] of Char ;
   Size: DWORD;
   s : string ;
begin
	Size := 256;
   if (WNetGetConnection(PChar(drv), ShareName, Size) = NO_ERROR) then
		s := string(ShareName)
   else
		s := drv ;
   Result := s ;
end;

// N
procedure TForm3.FormShow(Sender: TObject);
var
   s : string ;
begin
   Timer1.Interval := 0 ;
   Timer1.Enabled := False ;

   Edit1.Text := IntToStr(BTime) ;
   LabelA.Caption := GetJWWFilePath ;
	ShortDateFormat := 'yyyy/mm/dd';
	s := DateToStr(Now);
	LabelB.Caption := s ;
	LongtimeFormat := 'hh:mm:ss';
	s := TimeToStr(Now);
	LabelC.Caption := s ;
   ListBox1.Items.Clear ;
   ListBox2.Items.Clear ;

   Button1.Enabled := True ;
   if not(Form1.IBDatabase1.Connected) then begin
      Button1.Enabled := False ;
      exit ;
   end;
   // e[umF
   if not(Form1.DataTableCheck(TABLE1)) then begin
      // e[u݂Ȃ̂Ńe[u쐬
      if not(Form1.DataTableMaking1) then
         Button1.Enabled := False ;
   end;
   Edit1.SetFocus ;
end;

// I
procedure TForm3.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   Timer1.Enabled := False ;
end;

// N`FbNJn
procedure TForm3.Button1Click(Sender: TObject);
var
   i : integer ;
begin
   i := SInt(Edit1.Text) ;
   if (i < 1) or (i > 999) then begin
      ShowMessage('`FbNԂ 1`999̐œ͂ĉ');
      Edit1.SetFocus;
      exit;
   end;
   Btime := i ;

   Edit1.Enabled := False ;

   Timer1.Interval := Btime * 1000 ;
	Timer1.Enabled := True ;
end;

// f
procedure TForm3.Button2Click(Sender: TObject);
begin
   Timer1.Interval := 0 ;
   Timer1.Enabled := False ;

   Edit1.Enabled := True ;
end;

// 
procedure TForm3.Button3Click(Sender: TObject);
begin
   close ;
end;

// N`FbNi^C}j
procedure TForm3.Timer1Timer(Sender: TObject);
var
	s,s1,s2,s3 : string ;
   i,j,k,l : integer ;
begin
	Timer1.Enabled := False ;

   LabelA.Caption := GetJWWFilePath ;
   LabelA.Update ;
	ShortDateFormat := 'yyyy/mm/dd';
	s := DateToStr(Now);
	LabelB.Caption := s ;
   LabelB.Update ;
	LongtimeFormat := 'hh:mm:ss';
	s := TimeToStr(Now);
	LabelC.Caption := s ;
   LabelC.Update ;

   // t@CI𒆂̏ꍇ̓LZ
   FileSelect := False ;
   EnumWindows(@EnumWndProcCheck, 0);
   if (FileSelect) then begin
      Timer1.Interval := Btime * 1000 ;
      Timer1.Enabled := True ;
      exit ;
   end;

   // ݋N̈ꗗListBox2ɓ܂
   ListBox2.Items.Clear ;
   EnumWindows(@EnumWndProc, 0);

   // Jw_cadt@C̃`FbN
   // AʃtH_̓t@C̏ꍇÂƌF̂Œ
	for i:=ListBox1.Items.Count-1 downto 0 do begin
		s := ListBox1.Items[i] ;
      j := AnsiPos(' :H',s);
		if (j > 0) then begin
	      s1 := Copy(s,j+3,Length(s));                          // nhԍ
         s  := AnsiUpperCase(ExtractFileName(Copy(s,1,j-1)));  // t@C
         l  := -1;
         for j:=0 to ListBox2.Items.Count-1 do begin
            s2 := ListBox2.Items[j] ;
   		   k  := AnsiPos(' :H',s2);
            if (k > 0) then begin
         		s3 := Copy(s2,k+3,Length(s2));                        // nhԍ
               s2 := AnsiUpperCase(ExtractFileName(Copy(s2,1,k-1))); // t@C
            	if (s1 = s3) then begin
                  // ʂ̃t@CJĂꍇɂ͏
                  if (s <> s2) then
                     ListBox1.Items.Delete(i);
                  l := j;
                  break;
               end;
            end;
         end;
         if (l = -1) then begin
            // nhȂJw_cadI
            ListBox1.Items.Delete(i);
         end;
      end;
   end;

   // VJJw_cadt@C̃`FbN
   for i:=0 to ListBox2.Items.Count-1 do begin
		s := ListBox2.Items[i] ;
      j := AnsiPos(' :H',s);
		if (j > 0) then begin
	      s1 := Copy(s,j+3,Length(s));  // nhԍ
         l  := -1;
         for j:=0 to ListBox1.Items.Count-1 do begin
            s2 := ListBox1.Items[j] ;
   		   k  := AnsiPos(' :H',s2);
            if (k > 0) then begin
         		s3 := Copy(s2,k+3,Length(s2));   // nhԍ
            	if (s1 = s3) then l := j;
            end;
         end;
         if (l = -1) then begin
            // nhȂVKǉ
            ListBox1.Items.Add(s);
            j := AnsiPos(' :H',s);
            if (j > 0) then
               s := Copy(s,1,j-1);
            DBDataAdd(s);
         end;
      end;
   end;

   Timer1.Interval := Btime * 1000 ;
   Timer1.Enabled := True ;
end;

// f[^o^
//    fn : VJJw_cadt@C
procedure TForm3.DBDataAdd(fn:string);
var
   n,i : integer ;
   fn1,fn2,fn3,s1,s2 : string ;
	sr : TSearchRec ;
	ti : TDateTime ;
   sr1,sr2,sr3 : string ;
   fs: array of string ;
   s : array of string ;
begin
   fn1:= fn ;
   fn2:= fn ;
	s1 := Copy(fn,1,1);
	s2 := Copy(fn,2,1);
	if (s1 >= 'D')and(s1 <= 'Z')and(s2 = ':') then begin
      s1  := GetNetDrive(s1 + s2);
		fn2 := s1 + Copy(fn,3,Length(fn));
   end;
   fn1 := ExtractFilePath(fn1);
   fn2 := ExtractFilePath(fn2);
   fn3 := ExtractFileName(fn);

   FindFirst(fn,(SysUtils.faAnyFile), sr);
   ti  := FileDateToDateTime(sr.Time) ;
   ShortdateFormat := 'yyyy/mm/dd';
   sr1 := DateToStr(ti) ;
	LongtimeFormat := 'hh:mm:ss' ;
   sr2 := TimeToStr(ti) ;
   sr3 := IntToStr(sr.Size) ;
	FindClose(sr);

   n := SInt(Form1.GetMaxValue(TABLE1,'N','')) + 1 ;

   SetLength(fs,10);
   SetLength(s ,10);

   fs[0] := 'N';
   fs[1] := 'PNAME';
   fs[2] := 'L_FOLDER';
   fs[3] := 'N_FOLDER';
   fs[4] := 'FILE_NAME';
   fs[5] := 'BOOT_DATE';
   fs[6] := 'BOOT_TIME';
   fs[7] := 'FILE_DATE';
   fs[8] := 'FILE_TIME';
   fs[9] := 'FILE_SIZE';

   s[0] := IntToStr(n) ;
   s[1] := Pname ;
   s[2] := QTrim(fn1) ;
   s[3] := QTrim(fn2) ;
   s[4] := QTrim(fn3) ;
   s[5] := LabelB.Caption ;
   s[6] := LabelC.Caption ;
   s[7] := sr1 ;
   s[8] := sr2 ;
   s[9] := sr3 ;

   for i:=1 to 8 do begin
      if (s[i] = '') then
         s[i] := 'NULL'
      else
         s[i] := '''' + s[i] + '''' ;
   end;

   Form1.TableAdd(TABLE1,10,fs,s);

   fs := nil ;
   s  := nil ;
end;

end.
